
 UNIT UnL01022 ;

 INTERFACE

 Const
   maxp  = 53 ;

 Type
   TPol  = Array[0..maxp] of Extended ;

 Procedure RecurentFormula ; { for Legandre polinoms }

 IMPLEMENTATION

 Uses
   UnForPrt ;

 Var
   pnul,pone,ptwo  : TPol ;

 Procedure NulloPol ; { for the initial value }
 Var
   nz  : Byte ;
 Begin
   For nz:=0 To maxp Do
     Begin
       pnul[nz]:=0.0;
       pone[nz]:=0.0;
       ptwo[nz]:=0.0;
     End;
   pnul[0]:=1.0; { P0(z)=1 }
   pone[1]:=1.0; { P1(z)=1 }
 End;

 Procedure RocirPol ( np  : Byte ) ; { to shift polinoms }
 Var
   nz  : Byte ;
 Begin
   For nz:=0 To np Do
     Begin
       pnul[nz]:=pone[nz];
       pone[nz]:=ptwo[nz];
       ptwo[nz]:=0.0;
     End;
 End;

 Procedure RecurPol ( np  : Byte ) ; { simple recurent }
 Var
   nz  : Byte ;
   rn  : Extended ;
   ra  : Extended ;
   rb  : Extended ;
 Begin
   rn:=1.0/np;
   ra:=(np-1)*rn;
   rb:=(2*np-1)*rn;
   For nz:=0 To np-2 Do
     ptwo[nz]:=-ra*pnul[nz];
   For nz:=1 To np Do
     ptwo[nz]:=ptwo[nz]+rb*pone[nz-1];
 End;

 Procedure PolWrite ( np : Byte ) ;
 Var
   nz  : Byte ;
 Begin
   WriteLn(ResFile,np:5,'   P(',np:1,')(z)');
   WriteLn(ResFile,((np+2) div 2):5,'  terms ');
   For nz:=0 To np Do
     If  Abs(ptwo[nz]) > 1.0e-6
       Then
         WriteLn(ResFile,nz:5,'  ',ptwo[nz]:45:16,'  *z^',nz:1);
 End;

 { to obtain the formula for each Legandre polinom
   or the numerical values of the coefficients an
   in the form
   Pn(z)=a0+a1*z+a2*z**2+a3*z**3+a4*z**4+...+an*z**n
   by the use recurent formula
   n*Pn(z)=(2*n-1)*z*P(n-1)(z)-(n-1)*P(n-2)(z),  P0(z)=1, P1(z)=z }
   
 Procedure RecurentFormula ;
 Var
  np  : Byte ;
 Begin
   NulloPol ;
   For np:=2 To maxp Do
     Begin
       RecurPol(np);
       PolWrite(np);
       RocirPol(np);
     End;
 End;

 END.
