
 UNIT UnL01026 ;

 INTERFACE

 Procedure PolLegToElem ;

 IMPLEMENTATION

 Uses
   UnForRec , UnForPrt ;

 { very simple operations with the Legandre Polinoms
   we have
   Pn(z) = a0+a1*z+a2*z^2+...+a_n*z^n;
   z=s*cos(S),
   z^k=b_00+b_01*s+b_02*s^2+b_03*s^3+...+b_0k*s^k+
      +...+
      +(b_j0+b_j1*s+b_j2*s^2+...+b_jk*s^k)*cos(j*S); j=1,2...,k.
   P_n(z) as a function of s^k and cos(k*S) }

 Var
   fp,fz  : Text ;
   NuMem  : Array [1..MaxPowM+1] of Word ;

 Procedure ToOpenTwoFiles ;
 Begin
   Assign(fp,'lect0201.res');
   ReSet(fp); { file form P_n(z) n=1,2,3,...,max }
   ToOpenResFile('lect0201.rep');
 End;

 Procedure AllRecToMemB ;
 Var
   rfile  : Text ;
   ntcur  : Byte ;
   power  : Byte ;
   nterm  : Byte ;
 Begin
   Assign(rfile,'lect0201.rez');
   ReSet(rfile); { file for z^k=(s*cos(S))^k, k=1,2,3,...,max }
   NumRecB:=0;
   While  NOT SeekEOF(rfile)  Do
     Begin
       ReadLn(rfile,power); { power of the expression }
       ReadLn(rfile,nterm); { number of terms }
       If  power <= MaxPowM
         Then
           NuMem[power]:=NumRecB; { the previous number in massive }
       For ntcur:=1 To nterm Do
         Begin
           NumRecB:=NumRecB+1; { the current record }
           If  NumRecB <= MaxDimR
             Then
               With  DimRecB^[NumRecB]  Do
                 ReadLn(rfile,np,na,am);
         End;
     End;
   NuMem[power+1]:=NumRecB;
   Close(rfile);
 End;

 Procedure ToCloseTwoFiles ;
 Begin
   Close(fp);
   ToCloseResFile;
 End;

 Procedure ForNulloP ( amp  : Extended ) ;
 Begin
   NumRecA:=NumRecA+1; { the next term }
   With  DimRecA^[NumRecA]  Do
     Begin { simple term  a*s^0*cos(0*S)=a }
       np:=0; { nullo power }
       na:=0; { nullo argument }
       am:=amp; { but there is amplitude }
     End;
 End;

 Procedure ForPowerA ( nzp  : Byte ;  amp  : Extended ) ;
 Var
   nt,it,mt  : Word ;
 Begin
   it:=NuMem[nzp]+1; { number of the first term for power nzp }
   mt:=NuMem[nzp+1]; { number of the  last term for power nzp }
   For nt:=it To mt Do
     Begin
       NumRecA:=NumRecA+1;
       DimRecA^[NumRecA].np:=DimRecB^[nt].np; { power }
       DimRecA^[NumRecA].na:=DimRecB^[nt].na; { in argument }
       DimRecA^[NumRecA].am:=amp*DimRecB^[nt].am; { amplitude }
     End;
 End;

 { terms for amp*(z/r)^nzp }

 Procedure ForPowerZ ( nzp  : Byte ;  amp  : Extended ) ;
 Begin
   If  nzp = 0
     Then
       ForNulloP(amp)
     Else
       ForPowerA(nzp,amp);
 End;

 Procedure AllRecFromA ( npcur  : Byte ) ;
 Var
   nrec  : Word ;
 Begin
   WriteLn(ResFile,npcur:5,'  PolLeg power P_',npcur:1,'(z/r)');
   WriteLn(ResFile,NumRecA:5,'  number of terms');
   For nrec:=1 To NumRecA Do
     With  DimRecA^[nrec]  Do
       WriteLn(ResFile,np:5,na:5,am:45:20,
                       '  p^',np:1,' * cos(',na:1,'*A)');
 End;

 Procedure PolLegToElem ;
 Var
   np,nt  : Byte ;
   maxpn  : Byte ;
   npcur  : Byte ;
   nterm  : Byte ;
   nzpow  : Byte ;
   ampzn  : Extended ;
 Begin
   GetMem(DimRecA,SizeOf(TRecDim)); { memory for the massives }
   GetMem(DimRecB,SizeOf(TRecDim)); { memory for the massives }
   ToOpenTwoFiles ;
   AllRecToMemB ;
   maxpn:=MaxPowM;
   For np:=2 To maxpn  Do
     Begin
       NumRecA:=0;
       ReadLn(fp,npcur); { power of the current polinom }
       ReadLn(fp,nterm); { number of terms }
       For nt:=1 To nterm Do
         Begin
           ReadLn(fp,nzpow,ampzn); { power and amplitude of the term }
           If  np = npcur  Then  ForPowerZ(nzpow,ampzn);
         End;
       If  np = npcur  Then  AllRecFromA(npcur);
     End;
   ToCloseTwoFiles ;
   FreeMem(DimRecB,SizeOf(TRecDim));
   FreeMem(DimRecA,SizeOf(TRecDim));
 End;

 END.
