
 { lecture 3 seminar 1:   analytical operations
   to compare two numerical value for the parameters
   r=a*(1-e*cos(E)) and 1/r=(1/p)*(1+e*cos(v)) in power k
   general expressions for  any power is in file lect0301.res
   to compare two numerical value for   (r_0/r)^(n-1)*P_n(z/r)
   general expressions for some power is in file lect0301.rez }


 UNIT UnL02011 ;

 INTERFACE

 Procedure ToCompValue ( ch  : Char ) ;

 Procedure ToCompZonHarm ;

 IMPLEMENTATION

 Uses
   UnConTyp , UnForPrt , UnL01012 , UnForRec ;

 Procedure ToObtainParm ( ch  : Char ;
                          a , e , u  : Extended ;
                          Var   p ,q , r  : Extended ) ;
 Begin
   If  ch = 'E'
     Then { for E - eccentric anomaly }
       Begin { r=a*(1-e*cosE) }
         p:=-e;
         q:=a/GeoR0;
         r:=q*(1+p*Cos(u));
         WriteLn('eccentric anomaly');
         WriteLn(PrtFile,'to compare (a/r0*(1-e*cos(E))**k');
       End
     Else { for v - true anomaly }
       Begin { 1/r=(1+e*cosv)/(a*(1-e**2) }
         p:=+e;
         q:=GeoR0/(a*(1-Sqr(e)));
         r:=q*(1+p*Cos(u));
         WriteLn('true anomaly');
         WriteLn(PrtFile,'to compare ((r0/a*(1-e*e))*(1+e*cos(v))**k');
       End;
   WriteLn('a=',a:15:6,'  km,  e=',e:15:9,
           ',   angle=',RadGra*u:15:9,'  degree');
   WriteLn(PrtFile,'    a=',a:15:6,'  km');
   WriteLn(PrtFile,'    e=',e:15:9);
   WriteLn(PrtFile,'angle=',RadGra*u:15:9,'  degree');
   WriteLn(PrtFile,'  k   n',' ':20,'value in km',' ':19,'dif');
 End;

 { for  r**power only simple numerical }

 Function ToPower ( power  : Byte ;  r  : Extended ) : Extended ;
 Var
   n  : Byte ;
   a  : Extended ;
 Begin
   a:=1; { nullo power }
   For n:=1 To power Do  a:=r*a;
   ToPower:=a; { for  r**power }
 End;

 Procedure ToMakeComp ( ch  : Char ;  a , e , u  : Extended ) ;
 Var
   power  : Byte ;
   mterm  : Word ;
   nterm  : Word ;
   p,q,r  : Extended ;
   rr,qq  : Extended ;   
   np,na  : Byte ;
   rampl  : Extended ;
   rcomp  : Extended ;
   dcomp  : Extended ;
   scomp  : String ;
 Begin
   ToObtainParm(ch,a,e,u,p,q,r);
   ReSet(ResFile); { from UnL01010 }
   While  NOT SeekEOF(ResFile)  Do
     Begin
       ReadLn(ResFile,power);
       rr:=ToPower(power,r);
       qq:=ToPower(power,q);
       ReadLn(ResFile,mterm);
       rcomp:=0.0;
       For nterm:=1 To mterm Do
         Begin
           ReadLn(ResFile,np,na,rampl);
           rcomp:=rcomp+rampl*qq*ToPower(np,p)*Cos(na*u);
         End;
       dcomp:=rcomp-rr;
       If  ( ( 1.0e-15 < rr ) AND ( rr < 1.0e16 )
             AND ( Abs(dcomp) < 1.0e4 ) )
         Then
           If  Abs(dcomp) < 1.0e-15
             Then
               Begin
                 Str(dcomp:12,scomp);
                 Delete(scomp,9,2);
                 WriteLn(PrtFile,power:3,mterm:4,rr:35:15,scomp:22);
               End
             Else
               WriteLn(PrtFile,power:3,mterm:4,rr:35:15,dcomp:30:15);
      End;
 End;

 Procedure ToCompValue ( ch  : Char ) ;
 Var
   nv,na  : Byte ;
   nrand  : Word ;
   a,e,u  : Extended ;
 Begin
   ForInitComp ; { from UnL01012 }
   For nv:=1 To mvar Do
     Begin
       a:=avar[nv]; { from UnL01012 }
       e:=evar[nv];
       For na:=1 To maxa Do
         Begin
           nrand:=Random(360); { from 0 to 360 in degree }
           u:=GraRad*nrand; { angle in radian }
           ToMakeComp(ch,a,e,u);
         End;
     End;
 End;

 Procedure ToWriteElemInform ( nv , na  : Byte ;
                               a , e , s , u , v  : Extended ) ;
 Begin
   WriteLn('  variant',nv:5,na:5);
   WriteLn('  a=',a:15:6,'  e=',e:15:6,'  i=',s:15:6);
   WriteLn('  u=',u:15:6,'  v=',v:15:6);
   WriteLn(PrtFile,'  variant',nv:5,na:5);
   WriteLn(PrtFile,'  a=',a:15:6,'  e=',e:15:6,'  i=',s:15:6);
   WriteLn(PrtFile,'  u=',u:15:6,'  v=',v:15:6);
   WriteLn(PrtFile,'n':5,'nt':10,'value':30,'dif':18);
 End;

 Procedure ToMakeZonComp ( p , e , s , u , v  : Extended ) ;
 Var
   ip,kp  : Byte ;
   mterm  : Word ;
   nt,kt  : Word ;
   rr,rp  : Extended ;
   zr,p0  : Extended ;
   p1,p2  : Extended ;
   pp,ss  : Extended ;
   qn,zp  : Extended ;
   zreco  : TRecZon ;
   rcomp  : Extended ;
   dcomp  : Extended ;
   scomp  : String ;
 Begin
   rr:=p/(1+e*Cos(v));
   rr:=GeoR0/rr; { r_0/r }
   zr:=s*Sin(u); { z/r }
   pp:=GeoR0/p; { r_0/p}
   ss:=-s; { -sin(i) }
   ReSet(ResFile); { from UnL01010 file with the name 'lect0301.rez' }
   While  NOT SeekEOF(ResFile)  Do
     Begin
       ReadLn(ResFile,kp); { power of the zonal harmonic n }
       rp:=ToPower((kp-1),rr); { (r_0/r)^(n-1) }
       p0:=1;
       p1:=zr;
       For ip:=2 To kp Do
         Begin { simple recurrent formula for the legandre polinoms }
           qn:=ip;
           p2:=(2.0*qn-1.0)/qn*zr*p1-(qn-1.0)/qn*p0; { P_n(z/r) }
           p0:=p1;
           p1:=p2;
         End;
       zp:=rp*p2; { (r_0/r)^(n-1)*P_n(z/r) numerical }
       ReadLn(ResFile,mterm); { number of the terms }
       rcomp:=0.0;
       For nt:=1 To mterm Do
         With  zreco  Do
           Begin
             ReadLn(ResFile,kt,np[1],np[2],np[3],na[1],na[2],am);
             qn:=ToPower(Abs(np[1]),pp)*ToPower(np[2],e)*ToPower(np[3],ss);
             rcomp:=rcomp+am*qn*Cos(na[1]*(u+Pi/2)+na[2]*v);
         End;
       dcomp:=rcomp-zp;
       If  ( ( 1.0e-15 < Abs(zp) ) AND ( Abs(zp) < 1.0e16 ) )
         Then
           If  Abs(dcomp) < 1.0e-15
             Then
               Begin
                 Str(dcomp:12,scomp);
                 Delete(scomp,9,2);
                 WriteLn(PrtFile,kp:5,mterm:10,zp:30:16,scomp:22);
               End
             Else
               Begin
                 WriteLn(kp:5,mterm:10,zp:30:16,dcomp:30:16);
                 WriteLn(PrtFile,kp:5,mterm:10,zp:30:16,dcomp:30:16);
               End;
      End;
   Close(ResFile);
 End;

 { to compare two numerical value for   (r_0/r)^(n-1)*P_n(z/r)
   general expressions for some power is in file lect0301.rez }

 Procedure ToCompZonHarm ;
 Var
   nv,na  : Byte ;
   nrand  : Word ;
   a,e,s  : Extended ;
   u,v,p  : Extended ;
 Begin
   ForInitComp ; { for some values of the elements  a, e, i  from UnL01012 }
   For nv:=1 To mvar Do
     Begin
       a:=avar[nv]; { semi-major axis from UnL01012 }
       e:=evar[nv]; { eccentricity }
       s:=Sin(GraRad*vinc[nv]); { sin of the inclination }
       p:=a*(1-Sqr(e)); { simple parametr of the ellipse }
       For na:=1 To maxa Do
         Begin
           nrand:=Random(360); { from 0 to 360 in degree }
           u:=GraRad*nrand; { argument of latitude in radian }
           nrand:=Random(360); { from 0 to 360 in degree }
           v:=GraRad*nrand; { true anomaly in radian }
           ToWriteElemInform(nv,na,a,e,vinc[nv],RadGra*u,RadGra*v);
           ToMakeZonComp(p,e,s,u,v);
         End;
     End;
 End;

 END.