
 { lecture 3 seminar 1: analitycal operations
   more complex exercise
   to build the expressions for  (r_0/r)^(n-1)*P_n(z/r)
   as a function of parameters p=a*(1-e^2), e, i, u~=u+Pi/2, v }

 UNIT UnL02012 ;

 INTERFACE

 Procedure ForZonalTerms ;

 IMPLEMENTATION

 Uses
   UnForRec , UnForPrt ;

 Const
   mz  = 13 ;

 Var
   nm  : Array[1..2,1..mz+1] of Word ;

 Procedure ToGetMemory ;
 Begin { massives of the pointers are declared in the unit UnForRec }
   GetMem(DimRecA,SizeOf(TRecDim)); { memory for the simple massives }
   GetMem(DimRecB,SizeOf(TRecDim)); { memory for the simple massives }
   GetMem(ZonRecA,SizeOf(TZonDim)); { memory for more complex massive }
   GetMem(ZonRecB,SizeOf(TZonDim)); { memory for more complex massive }
   GetMem(ZonRecC,SizeOf(TZonDim)); { memory for more complex massive }
 End;

 Procedure ToFreeMemory ;
 Begin { massives of the pointers are declared in the unit UnForRec }
   FreeMem(ZonRecC,SizeOf(TZonDim)); { memory for more complex massive }
   FreeMem(ZonRecB,SizeOf(TZonDim)); { memory for more complex massive }
   FreeMem(ZonRecA,SizeOf(TZonDim)); { memory for more complex massive }
   FreeMem(DimRecB,SizeOf(TRecDim)); { massives are declared }
   FreeMem(DimRecA,SizeOf(TRecDim)); { in the unit  UnForRec }
 End;

 Procedure ToFillDimRec ( mr  : Byte ;
                          sr  : String ;
                          Var  dimr  : TDimPtr ) ;
 Var
   fr  : Text ;
   nr  : Word ;
   kp  : Byte ;
   it  : Word ;
   kt  : Word ;
   ra  : TRecOne ;
 Begin
   Assign(fr,sr);
   ReSet(fr);
   nr:=0;
   kp:=0;
   While  ( NOT SeekEOF(fr) AND ( kp < mz ) )  Do
     Begin
       ReadLn(fr,kp); { power of the expression }
       ReadLn(fr,kt); { number of the terms in this expression }
       If  kp <= MaxPowM { from UnForRec }
         Then
           nm[mr,kp]:=nr; { the previous number in massive }
       For it:=1 To kt Do
         Begin
           nr:=nr+1;
           If  nr <= MaxDimR { from UnForRec }
             Then
               With  dimr^[nr]  Do
                 ReadLn(fr,np,na,am) { one simple record }
             Else
               ReadLn(fr);
         End;
     End;
   nm[mr,kp+1]:=nr;
   Close(fr);
 End;

 { to change simple record to more complex record }

 Procedure ForTwoExpressions ( np  : Byte ) ;
 Var
   ip  : Byte ;
 Begin
   NumRecA:=0; { the first expression for P_n(z/r) sin(i)^j * cos(ku~) }
   For ip:=nm[1,np]+1 To nm[1,np+1] Do
     Begin { for all terms of power np }
       NumRecA:=NumRecA+1;
       ZonRecA^[NumRecA].np[1]:=0; { power for p=a*(1-e^2) }
       ZonRecA^[NumRecA].np[2]:=0; { power for e }
       ZonRecA^[NumRecA].np[3]:=DimRecA^[ip].np; { power for -sin(i) }
       ZonRecA^[NumRecA].na[1]:=DimRecA^[ip].na; { coefficient for u~ }
       ZonRecA^[NumRecA].na[2]:=0; { coefficient for v }
       ZonRecA^[NumRecA].am:=DimRecA^[ip].am; { amplitude }
     End;
   NumRecB:=0; { the second expression (r_0/r)**(np-1)  e^j * cos(kv) }
   For ip:=nm[2,np-1]+1 To nm[2,np] Do
     Begin { for all terms but power is np-1 }
       NumRecB:=NumRecB+1;
       ZonRecB^[NumRecB].np[1]:=-(np-1); { power for p=a*(1-e^2) }
       ZonRecB^[NumRecB].np[2]:=DimRecB^[ip].np; { power for e }
       ZonRecB^[NumRecB].np[3]:=0; { power for -sin(i) }
       ZonRecB^[NumRecB].na[1]:=0; { coefficient for u~ }
       ZonRecB^[NumRecB].na[2]:=DimRecB^[ip].na; { coefficient for v }
       ZonRecB^[NumRecB].am:=DimRecB^[ip].am; { amplitude }
     End;
 End;

 { simple case when coefficient with u~ or v equal nullo
   one term  cos(0*u~+k*v) or cos(j*u~+0*v)}

 Procedure NulloCaseU ( ia , ib  : Word ) ;
 Var
   rc  : Extended ;
 Begin
   If  NumRecC = MaxDimZ  Then  Exit ; { too many terms }
   NumRecC:=NumRecC+1; { only one term  cos(0*u~+k*v) or cos(j*u~+0*v) }
   rc:=ZonRecA^[ia].am*ZonRecB^[ib].am; { amplitude }
   ZonRecC^[NumRecC].np[1]:=ZonRecB^[ib].np[1]; { power for p }
   ZonRecC^[NumRecC].np[2]:=ZonRecB^[ib].np[2]; { power for e }
   ZonRecC^[NumRecC].np[3]:=ZonRecA^[ia].np[3]; { power for i }
   ZonRecC^[NumRecC].na[1]:=ZonRecA^[ia].na[1]; { coef. for u~ or nullo }
   ZonRecC^[NumRecC].na[2]:=ZonRecB^[ib].na[2]; { coef. for v  or nullo }
   ZonRecC^[NumRecC].am:=rc;
 End;

 { simple case when coefficient with u~ not equal nullo
   two terms 
   cos(j*u~)*cos(k*v)=0.5*cos(j*u~-k*v)+0.5*cos(j*u~+k*v) }

 Procedure OtherCaseU ( ia , ib  : Word ) ;
 Var
   rc  : Extended ;
 Begin
   If  NumRecC = MaxDimZ  Then  Exit ; { too many terms }
   rc:=0.5*ZonRecA^[ia].am*ZonRecB^[ib].am; { amplitude but half }
   NumRecC:=NumRecC+1; { the  first term for  cos(j*u~-k*v) }
   ZonRecC^[NumRecC].np[1]:=+ZonRecB^[ib].np[1]; { power for p }
   ZonRecC^[NumRecC].np[2]:=+ZonRecB^[ib].np[2]; { power for e }
   ZonRecC^[NumRecC].np[3]:=+ZonRecA^[ia].np[3]; { power for i }
   ZonRecC^[NumRecC].na[1]:=+ZonRecA^[ia].na[1]; { nullo for u~ }
   ZonRecC^[NumRecC].na[2]:=-ZonRecB^[ib].na[2]; { coef. for v }
   ZonRecC^[NumRecC].am:=rc;
   If  NumRecC = MaxDimZ  Then  Exit ; { too many terms }
   NumRecC:=NumRecC+1; { the second term for  cos(j*u~+k*v) }
   ZonRecC^[NumRecC].np[1]:=+ZonRecB^[ib].np[1]; { power for p }
   ZonRecC^[NumRecC].np[2]:=+ZonRecB^[ib].np[2]; { power for e }
   ZonRecC^[NumRecC].np[3]:=+ZonRecA^[ia].np[3]; { power for i }
   ZonRecC^[NumRecC].na[1]:=+ZonRecA^[ia].na[1]; { nullo for u~ }
   ZonRecC^[NumRecC].na[2]:=+ZonRecB^[ib].na[2]; { coef. for v }
   ZonRecC^[NumRecC].am:=rc;
 End;

 { to multiply
   NumRecA  terms of  ZonRecA
   and
   NumRecB  terms of  ZonRecB
      with result in  ZonRecC }

 Procedure ToMultExpressions ;
 Var
   ia  : Word ;
   ib  : Word ;
 Begin { simple multiplication term by term }
   NumRecC:=0; { resulting massive is empty }
   For ia:=1 To NumRecA Do { for P_n(z/r) }
     For ib:=1 To NumRecB Do { for (r_0/r)^(n-1) }
       If  ( ( ZonRecA^[ia].na[1] = 0 )
            OR ( ZonRecB^[ib].na[2] = 0 ) )
         Then { case for cos(0*u~) or cos(0*v) }
           NulloCaseU(ia,ib)
         Else
           OtherCaseU(ia,ib);
 End;

 { number of records in resulting massive ZonRecC is NumRecC
   ResFile with the name 'lect0302.rez' is opened in lect0301.pas }

 Procedure ToWriteExpresToPrt ( ip  : Byte ) ;
 Var
  ic  : Word ;
 Begin
   WriteLn(PrtFile,ip:5,'  power of zonal harmonic');
   WriteLn(PrtFile,NumRecC:5,'  number of terms');
   WriteLn(PrtFile,'n':5,'p':10,'e':5,'i':5,'u':10,'v':5,'A':30);
   For ic:=1 To NumRecC Do
     With  ZonRecC^[ic]  Do
       WriteLn(PrtFile,ic:5,np[1]:10,np[2]:5,np[3]:5,
                            na[1]:10,na[2]:5,am:30:16);

 End;

 { number of records in resulting massive ZonRecC is NumRecC
   ResFile with the name 'lect0302.rez' is opened in lect0301.pas }

 Procedure ToWriteExpressions ( ip  : Byte ) ;
 Var
  ic  : Word ;
 Begin
   WriteLn('(r_0/r)**',ip-1:1,'*P_(',ip:1,')(z/r)',
           NumRecC:10,'  terms');
   WriteLn(PrtFile,'(r_0/r)**',ip-1:1,'*P_(',ip:1,')(z/r)',
                   NumRecC:10,'  terms');
   If  ( ip in [ 2 , 3 , 4 , 5 ] )
     Then
       ToWriteExpresToPrt(ip);
   WriteLn(ResFile,ip:5,'  power of zonal harmonic');
   WriteLn(ResFile,NumRecC:5,'  number of terms');
   For ic:=1 To NumRecC Do
     With  ZonRecC^[ic]  Do
       WriteLn(ResFile,ic:5,np[1]:10,np[2]:5,np[3]:5,
                            na[1]:10,na[2]:5,am:30:16);
 End;

 { some comments:
   in unit UnForRec is declared type TRecZon
   in file  lect0201.rep
   are the expressions for P_n(z/r) ( 2 <= n <= 50 )
       in general form as sum the terms p^j * cos(k*A)
   in file  lect0201.rez
   are the expressions for (1/r)^n  ( 1 <= n <= 50 )
       in general form as sum the terms p^j * cos(k*A)
   our goal is to multiple two expressions in simple manner }

 Procedure ForZonalTerms ;
 Var
   ip  : Byte ;
 Begin
   WriteLn('some zonal harmonics as functions of the elements');
   WriteLn(PrtFile,' some zonal harmonics as functions of the elements');
   ToGetMemory ;
   ToFillDimRec(1,'lect0201.rep',DimRecA); { expres. for  P_n(z/r) }
   ToFillDimRec(2,'lect0301.res',DimRecB); { expres. for (r_0/r)^n }
   { mz - maximum power for (r_0/r)^(n-1)*P_n(z/r) }
   For ip:=2 To mz Do
     Begin
       ForTwoExpressions(ip);
       ToMultExpressions ; { a very simple multiplications }
       ToWriteExpressions(ip); { to write result to file 'lect0301.rez' }
     End;
   ToFreeMemory ;
 End;

 END.
