
 { for analytic integration of the zonal harmonics expressions
   zonal harmonic expressions harmonic by harmonic
   and term by term are contained in the file lect0301.rez }

 UNIT UnL02021 ;

 INTERFACE

 Procedure ToIntegrZonHarm ;

 IMPLEMENTATION

 Uses
   UnForRec , { unit with the record type }
   UnForPrt ; { for ResFile and PrtFile }

 { secular or long periodic term }

 Procedure ForSeculTerm ( zh  : TRecZon ;  Var  zr  : TRecZon ) ;
 Begin
   zr:=zh;
   zr.bf:='Z'; { index for secular term }
 End;

 { short periodic term }

 Procedure ForShortTerm ( zh  : TRecZon ;  Var  zr  : TRecZon ) ;
 Var
   ka  : ShortInt ;
 Begin
   zr:=zh;
   ka:=zr.na[1]+zr.na[2];
   zr.am:=zr.am/ka; { amplitude after integration }
   zr.bf:='S'; { function sinus for short periodic term }
 End;

 { one term simple integration }

 Procedure OneTermIntegr ( zh  : TRecZon ;  Var  zr  : TRecZon ) ;
 Var
   ka  : ShortInt ;
 Begin
   ka:=zh.na[1]+zh.na[2]; { argument ka=k1+k2 where k1*(v+g)+k2*v }
   If  ka = 0
     Then { simple secular or long periodic term }
       ForSeculTerm(zh,zr)
     Else { simple short periodic term }
       ForShortTerm(zh,zr);
 End;

 Procedure ToWriteIntRes ( nh  : Byte ;  nn  : Word ;  zr  : TRecZon ) ;
 Begin
   With  zr  Do
     WriteLn(ResFile,nn:5,np[1]:6,np[2]:4,np[3]:4,
                          na[1]:6,na[2]:4,am:30:16,bf:2);
   If  ( nh in [ 2 , 3 , 4 ] )
     Then
       With  zr  Do
         Begin
           WriteLn(nn:5,np[1]:6,np[2]:4,np[3]:4,
                   na[1]:6,na[2]:4,am:30:16,bf:2);
           WriteLn(PrtFile,nn:5,np[1]:6,np[2]:4,np[3]:4,
                           na[1]:6,na[2]:4,am:30:16,bf:2);
         End;
 End;

 { the result of analytic integration to  ResFile  lect0202.res }

 Procedure ToIntegrZonHarm ;
 Var
   fh  : Text ;
   zh  : TRecZon ;
   zr  : TRecZon ;
   nh  : Byte ;
   mh  : Byte ;
   nt  : Word ;
   nc  : Word ;
   nn  : Word ;
   kt  : Word ;
 Begin
   WriteLn(PrtFile,'for analytic integration');
   Assign(fh,'lect0301.rez'); { file with the expressions }
   ReSet(fh);
   zh:=zonullo;
   mh:=11; { maximum number for zonal harmonic }
   nh:=0; { initial number for zonal harmonic }
   kt:=0; { for all number of the terms }
   While  ( ( NOT SeekEOF(fh) ) AND ( nh < mh ) ) Do
     Begin
       ReadLn(fh,nh);
       WriteLn(ResFile,nh:5); { to ResFile the order }
       ReadLn(fh,nt);
       WriteLn(ResFile,nt:5); { to ResFile number of terms }
       WriteLn('order',nh:5,'  terms',nt:10);
       WriteLn(PrtFile,'order',nh:5,'  terms',nt:10);
       For nn:=1 To nt Do
         Begin
           With  zh  Do
             ReadLn(fh,nc,np[1],np[2],np[3],na[1],na[2],am);
           OneTermIntegr(zh,zr);
           ToWriteIntRes(nh,nn,zr);
           kt:=kt+1;
         End;
     End;
   Close(fh);
   WriteLn('          maximum order  is',mh:10);
   WriteLn('all number of the terms  is',kt:10);
   WriteLn(PrtFile,'          maximum order  is',mh:10);
   WriteLn(PrtFile,'all number of the terms  is',kt:10);
 End;

 END.